O = 35;
Q = 9;

% "true" parameters
%prior0 = normalise(rand(Q,1));
%transmat0 = mk_stochastic(rand(Q,Q));
%obsmat0 = mk_stochastic(rand(Q,O));

% training data
%T = 5;
%nex = 10;
%data1 = dhmm_sample(prior0, transmat0, obsmat0, T, nex);

% initial guess of parameters
prior1 = normalise(rand(Q,1));
transmat1 = mk_stochastic(rand(Q,Q));
obsmat1 = mk_stochastic(rand(Q,O));

%data1 = rand(8,2,10);

%data=[]
%for i=1:10
%data{1,i} = data1(:,:,i);
%end
data_c = [];
n_c = 20;

data_c(:,1) = top_n(n_c,'csv data\c1.txt');
data_c(:,2) = top_n(n_c,'csv data\c2.txt');
data_c(:,3) = top_n(n_c,'csv data\c3.txt');
data_c(:,4) = top_n(n_c,'csv data\c4.txt');
data_c(:,5) = top_n(n_c,'csv data\c5.txt');
data_c(:,6) = top_n(n_c,'csv data\c6.txt');


% improve guess of parameters using EM
[LL_c, prior_c, transmat_c, obsmat_c] = dhmm_em(data_c, prior1, transmat1, obsmat1, 'max_iter', 5);
LL_c
data = top_n(n_c,'csv data\c4.txt');


% use model to compute log likelihood
loglik_c = dhmm_logprob(data, prior_c, transmat_c, obsmat_c)
% log lik is slightly different than LL(end), since it is computed after the final M step
